//
//  BalanceViewController.m
//  Balance
//
//  Created by aka on 08/12/22.
//  Copyright Masayuki Akamatsu 2008. All rights reserved.
//

#import "BalanceViewController.h"


@implementation BalanceViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
// ビューの読み込みが完了した時に呼び出されるメソッド
- (void)viewDidLoad
{
    // スーパー・クラスのメソッドを呼び出す
	[super viewDidLoad];

	// 位置の初期値を設定
	positionX = 160.0;
	positionY = 240.0;
	
	// 速度の初期値を設定
	speedX = 0.0;
	speedY = 0.0;
	
	// 加速度の初期値を設定
	accelX = 0.0;
	accelY = 0.0;
	
	// 加速度センサーの利用
	// 加速度センサーのインスタンスを取得
	UIAccelerometer *accelerometer = [UIAccelerometer sharedAccelerometer];
	// 加速度センサーの値を得る時間間隔を指定
	accelerometer.updateInterval = 0.02;
	// 加速度センサーの値を受け取るデリゲートを自分自身に設定
	accelerometer.delegate = self;
	
	// 効果音の準備
	NSString *path = [[NSBundle mainBundle] pathForResource:@"Beep" ofType:@"caf"];
	NSURL *url = [NSURL fileURLWithPath:path]; 
	AudioServicesCreateSystemSoundID((CFURLRef)url, &soundID);
	
	// 自動ロックの禁止
	UIApplication *application = [UIApplication sharedApplication];
	application.idleTimerDisabled = YES;
}


- (void)accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration *)acceleration
{
	// 加速度センサーの処理
	// インスタンス変数に加速度の値を代入
	accelX = acceleration.x;
	accelY = acceleration.y;
	accelZ = acceleration.z;
/*	
	// ハイパス・フィルタを掛けて、瞬間的な動きを取り除く
#define kFilteringFactor 0.1 

	double x = acceleration.x;
	double y = acceleration.y;
	double z = acceleration.z;
	
	accelX = x - ((x * kFilteringFactor) + (accelX * (1.0 - kFilteringFactor))); 
	accelY = y - ((y * kFilteringFactor) + (accelY * (1.0 - kFilteringFactor))); 
	accelZ = z - ((z * kFilteringFactor) + (accelZ * (1.0 - kFilteringFactor)));
*/	
	// ボールを移動させる
	[self move];
	
	//NSLog(@"%f %f %f",accelX, accelY, accelZ);
}

// ボールを移動させるメソッド
- (void)move
{
	// 加速度から速度を計算
	speedX = speedX + accelX;
	speedY = speedY - accelY;
	
	// 速度から位置を計算
	positionX = positionX + speedX;
	positionY = positionY + speedY;
	
	// ボールと左側のフレームとの衝突判定
	if (positionX <= 80)
	{
		// ボールが跳ね返るよう位置と速度を設定
		speedX *= -1;
		positionX = 80 + (80 - positionX);
		// フレームを光らせる
		[self flash];
	}
	
	// ボールと右側のフレームとの衝突判定
	if (positionX >= 240)
	{
		// ボールが跳ね返るよう位置と速度を設定
		speedX *= -1;
		positionX = 240 - (positionX - 240);
		// フレームを光らせる
		[self flash];
	}
	
	// ボールと上側のフレームとの衝突判定
	if (positionY <= 80)
	{
		// ボールが跳ね返るよう位置と速度を設定
		speedY *= -1;
		positionY = 80 + (80 - positionY);
		// フレームを光らせる
		[self flash];
	}
	
	// ボールと下側のフレームとの衝突判定
	if (positionY >= 400)
	{
		// ボールが跳ね返るよう位置と速度を設定
		speedY *= -1;
		positionY = 400 - (positionY - 400);
		// フレームを光らせる
		[self flash];
	}
	
	// 計算した位置にボールを移動
	ball.center = CGPointMake(positionX, positionY);
}

// フレームを光らせるメソッド
- (void)flash
{
	// 効果音を鳴らす
	AudioServicesPlayAlertSound(soundID);

	// アルファ値を1.0にして光るフレームを表示
	flash.alpha = 1.0;
	
	// 1秒かけてアルファ値を0.0に変化させる
	[UIView beginAnimations:nil context:nil];
	[UIView setAnimationDuration:1.0];
	
	flash.alpha = 0.0;

	[UIView commitAnimations];
}



/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc
{
    [super dealloc];
}

@end
